package org.eclipse.graphiti.examples.diagram;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EcoreFactory;
import org.eclipse.graphiti.features.ICreateFeature;
import org.eclipse.graphiti.features.IFeatureProvider;
import org.eclipse.graphiti.features.context.ICreateContext;
import org.eclipse.graphiti.features.impl.AbstractCreateFeature;
import org.eclipse.graphiti.mm.pictograms.Diagram;

public class CreateEClassFeature extends AbstractCreateFeature implements
		ICreateFeature {

	public CreateEClassFeature(IFeatureProvider fp) {
		super(fp, "EClass", "Creates a new EClass");
	}

	@Override
	public boolean canCreate(ICreateContext context) {
		return context.getTargetContainer() instanceof Diagram;
	}

	@Override
	public Object[] create(ICreateContext context) {
		EClass newClass = EcoreFactory.eINSTANCE.createEClass();
		getDiagram().eResource().getContents().add(newClass);
		addGraphicalRepresentation(context, newClass);
		return new Object[] { newClass };
	}

}
